<?php

function woowa_activate_license_callback($post){ 
   $domain = $_SERVER['SERVER_NAME'];
   $license_key = $license_key = (isset( $_POST['my-license'])) ? sanitize_text_field ($_POST['my-license']) : '' ; 

   $api_params = array(
      'plm_action' => 'plm_activate',
      'secret_key' => MY_VERIFICATION_KEY,
      'license_key' => $license_key,
      'registered_domain' => $domain,
      'version' => 'premium'
   ); 

   $response = wp_remote_get( add_query_arg( $api_params, MY_HOST_SERVER ), array( 
      'timeout' => 20, 
      'sslverify' => false 
   )); 

   $license_data = json_decode( wp_remote_retrieve_body( $response ) );
   if ( is_wp_error( $response ) || empty($license_data->product_name) ){
      update_option('errorlicense', 1);
      $license_data = array( 
         'result' => 'error',
         'message' => "Unexpected Error! The query returned with an error."
      ); 
      
   }else{
      update_option('errorlicense', 1);
      // echo "<pre>".print_r($response,1)."</pre>asd";
      if ($license_data->result=='error' || empty($license_data->product_name)) {
         update_option('errorlicense', 1);
      }else{
         update_option('errorlicense', 0);
         update_option("woowa_license",'active');
         update_option("woowa_license_number",$post['my-license']);
         if (strpos(strtolower($license_data->product_name), 'android') == true) { 
            update_option('woowa_license_type','android');
         }else if(strpos(strtolower($license_data->product_name), 'multivendor') == true){
            update_option('woowa_license_type','multivendor');
         }else {
            update_option('woowa_license_type', '');
         }
      }
      woowa_writelog("license : ".$license_data->message."");
      $api_key = trim($license_data->api_key);
      $ip = trim($license_data->ip);
      
      update_option('woowa_ip', $ip);
      update_option('woowa_api_key', $api_key);
   }

   return $license_data->message; 
}

if (get_option('errorlicense') == 1) {
   add_action( 'admin_notices', 'woowa_notif_errorlicense' );
}

function woowa_notif_errorlicense() {
	$class = 'notice notice-error';
   $message = __( 'Woowa Notice : License invalid. please contact CS at <a href="https://www.messenger.com/t/woowhatsapp" target="_blank">here</a> !');

	printf( '<div style="margin-left: 0px;" class="%1$s"><p>%2$s</p></div>', esc_attr( $class ),  $message  ); 
}

function woowa_cek_license_expired(){
	$license=get_option('woowa_license_number');
	$url=CEK_EXPIRED.$license;
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL,$url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$expired_date = curl_exec($ch);
	$err = curl_error($ch);
	curl_close ($ch);

	return $expired_date;
}

function woowa_deactivate_license_callback(){ 
   $license_key = ( isset( $_POST['my-license'] ) ) ? sanitize_text_field ( $_POST['my-license']) : '' ; 
   $domain = $_SERVER['SERVER_NAME']; 
   $api_params = array( 
      'plm_action' => 'plm_deactivate', 
      'secret_key' => MY_VERIFICATION_KEY, 
      'license_key' => $license_key, 
      'registered_domain' => $domain, 
   ); 

   $response = wp_remote_get( add_query_arg( $api_params, MY_HOST_SERVER ), array( 
      'timeout' => 20, 
      'sslverify' => false 
   ));

   if ( is_wp_error( $response ) ){ 
      $license_data = array( 
         'result' => 'error', 
         'message' => "Unexpected Error! The query returned with an error." 
      ); 
   }else{ 
      $license_data = json_decode( wp_remote_retrieve_body( $response ) ); 
      update_option("woowa_license",'deactive');
      update_option("woowa_license_number",'');
   } 
   //echo 'deactivate_license_callback'; 

   return $license_data->message;
}

function woowa_save_ip_key(){
   $ip = $_POST['ip'];
   $key = $_POST['key'];

   update_option('woowa_ip', $ip);
   update_option('woowa_api_key', $key);
   
   die();
}