<?php

class Main{

    public function send_message($data){
        if (get_option('woowa_license_type') == 'android') {
            $response = $this->send_message_android($data);
        }else {
            $response = $this->send_message_website($data);
        }

        return $response;
    }

    public function send_message_website($data){
        $data_api = $data['data_api'];
        
        $ip       = $data_api['ip'];
        $key      = $data_api['key'];
        $text     = $data_api['text'];
        $type     = $data_api['type'];
        $order_id = $data_api['order_id'];
        $no_wa    = $data_api['no_wa_tujuan'];

        $type     = str_replace('_', ' ', $type);
        $type     = strtoupper($type);

        $no_wa = $this->phone_validation($no_wa,'');
        
        $data_api    = array("phone_no" => $no_wa, "message" => $text, "key" => $key);
        $data_string = json_encode($data_api);
        $url = 'http://116.203.92.59/api/async_send_message';

        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST"); 
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_VERBOSE, 0);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json',
            'Content-Length: ' . strlen($data_string)) 
        );                                                                                            
        $result = curl_exec($ch);
        curl_close($ch);

        $data['log'];
        if (strpos($result, "403 Forbidden")!==false) {
            woowa_writelog("Key Invalid. Please deactive then activate the plugin to get latest key from server.");
            $result="Key Invalid";
        }

        if (strpos($type, "SELLER") !== false) {
            $data['log'] = '( SELLER ) '.$type.' #'.$order_id.' - Send Message to '.$no_wa."( $result )";
        }else {
            $data['log'] = '( CUSTOMER ) '.$type.' #'.$order_id.' - Send Message to '.$no_wa."( $result )";
        }

        return $data;
    }

    public function send_schedule_message($data){
        if (get_option('woowa_license_type') == ('android')) {
            if (get_option('woowa_android_version') != 'version1') {
                $time      = $data_api['order_complete_followup'];
                $text      = htmlspecialchars($data['text']);
                $file      = $data['file'];
                $type      = $data['type'];
                $order_id  = $data['order_id'];
                $player_id = $data['player_id'];
                $no_wa     = $data['no_wa_tujuan'];

                $playerID  = trim($value['player_id']);
                $param = array(
                    'data' => array(
                        "message"    => $text,
                        "schedule"   => $time,
                        "number"     => $data['no_wa_tujuan']
                    ),
                    'to' => $playerID
                );
                
                $data_json = json_encode($param);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, 'https://fcm.googleapis.com/fcm/send');
                curl_setopt( $ch,CURLOPT_POST, true );
                curl_setopt( $ch,CURLOPT_RETURNTRANSFER, true );
                curl_setopt( $ch,CURLOPT_POSTFIELDS, $data_json);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    'Content-Type: application/json',
                    'Authorization: Bearer AIzaSyCyXH1aC4rWgMQhaJuQLUTDXfWRBgrCZF4')); //os_auth don't change
                $response = curl_exec($ch);
                curl_close($ch);
                
                $log = '( CUSTOMER ) '.$type.' #'.$order_id.' - Set Schedule at '.$time.' for '.$no_wa."( $response )";
            }
        }else {
            $data_api = $data['data_api'];
            
            $ip       = $data_api['ip'];
            $key      = $data_api['key'];
            $text     = $data_api['text'];
            $type     = $data_api['type'];
            $order_id = $data_api['order_id'];
            $no_wa    = $data_api['no_wa_tujuan'];
            $time     = $data_api['order_complete_followup'];
    
            $type     = str_replace('_', ' ', $type);
            $type     = strtoupper($type);

            $url='http://116.203.92.59/api/scheduler';
            $data_curl = array(
                "phone_no" => $no_wa,
                "key"      => $key,
                "sch_date" => $time,
                "api_type" => 'text', // (text, image_text, image, file)
                "message"  => $text,
            );
    
            $data_string = json_encode($data_curl);
    
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_VERBOSE, 0);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
            curl_setopt($ch, CURLOPT_TIMEOUT, 360);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Content-Length: ' . strlen($data_string))
            );
            $response = curl_exec($ch);
            curl_close($ch);
            
            $log = '( CUSTOMER ) '.$type.' #'.$order_id.' - Set Schedule at '.$time.' for '.$no_wa."( $response )";
            
            if ($response == 'sch_more_than_3_in_1_minute') {
                $data_api['order_complete_followup'] = date('Y-m-d H:i', strtotime($time .'+ 1 minutes'));
                $time     = $data_api['order_complete_followup'];
                $data['data_api'] = $data_api;
                $data['response'] = $response;
                
                $log = '( CUSTOMER ) '.$type.' #'.$order_id.' - Set Schedule at '.$time.' for '.$no_wa."( $response )";
            }
        }

        $data['log'] = $log;

        return $data;
    }

    public function send_image($data){
        
        $data_api = $data['data_api'];
        
        $ip       = $data_api['ip'];
        $key      = $data_api['key'];
        $file     = $data_api['file'];
        $order_id = $data_api['order_id'];
        $no_wa    = $data_api['no_wa_tujuan'];
        
        $no_wa = str_replace("+","",$no_wa);
        $no_wa = '+'.$no_wa;

        $data_file = array(
            "phone_no" => $no_wa,
            "key" => $key,
            "url" => $file
        );
        
        $data_string = json_encode($data_file);
        $url='http://116.203.92.59/api/async_send_image_url';
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST"); 
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_VERBOSE, 0);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 360);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json',
            'Content-Length: ' . strlen($data_string)) 
        ); 
        
        $response = curl_exec($ch);
        $err = curl_error($ch);
        curl_close($ch);

        if ($response == 'image_not_found 404') {
            $data['log'] = 'Your image was not found when sending a message to'.$no_wa;
        }else {
            $data['log'] = $response;
        }

        return $data['log'];
    }

    public function send_schedule_image($data){
        if (get_option('woowa_license_type') != 'android') {
            $data_api = $data['data_api'];

            $ip       = $data_api['ip'];
            $key      = $data_api['key'];
            $type     = $data_api['type'];
            $text     = $data_api['text'];
            $img_url  = $data_api['file'];
            $order_id = $data_api['order_id'];
            $no_wa    = $data_api['no_wa_tujuan'];
            $time     = $data_api['order_complete_followup'];

            $type     = str_replace('_', ' ', $type);
            $type     = strtoupper($type);

            $url='http://116.203.92.59/api/scheduler';
            $data_curl = array(
                "phone_no" => $no_wa,
                "key"      => $key,
                "sch_date" => $time,
                "api_type" => 'image_text', // (text, image_text, image, file)
                "message"  => $text, // (text, image_text, image, file)
                "url"      => $img_url
            );
            $data_string = json_encode($data_curl);

            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_VERBOSE, 0);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
            curl_setopt($ch, CURLOPT_TIMEOUT, 360);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json',
            'Content-Length: ' . strlen($data_string))
            );
            $response = curl_exec($ch);
            curl_close($ch);

            $log = '( CUSTOMER ) '.$type.' #'.$order_id.' - Set Schedule at '.$time.' for '.$no_wa."( $response )";
            
            if ($response == 'sch_more_than_3_in_1_minute') {
                $data_api['order_complete_followup'] = date('Y-m-d H:i', strtotime($time .'+ 1 minutes'));
                $time     = $data_api['order_complete_followup'];
                $data['data_api'] = $data_api;
                $data['response'] = $response;
                
                $log = '( CUSTOMER ) '.$type.' #'.$order_id.' - Set Schedule at '.$time.' for '.$no_wa."( $response )";
            }

            $data['log'] = $log;

            return $data;
        }
    }

    public function reschedule_send_message($data){
        $data_api = $data['data_api'];
        $time     = $data_api['order_complete_followup'];

        $this->writelog($time);
        $data['data_api']['order_complete_followup'] = date('Y-m-d H:i', strtotime($time .'+1 minutes', strtotime($time)));
        
        $this->writelog(json_encode($data));
        $this->send_schedule_message($data);
    }

    public function send_message_android($data){
        $text      = htmlspecialchars($data['text']);
        $file      = $data['file'];
        $type      = $data['type'];
        $order_id  = $data['order_id'];
        $player_id = $data['player_id'];
        $no_wa     = $data['no_wa_tujuan'];
        
        (strpos($type, "seller") === 0) ? $no_wa = $data['data_api']['no_wa_tujuan'] : $no_wa = $data['no_wa_tujuan'];
        
        $dataplayer = get_option('woowa_customer_service_data');
        $dataplayer = json_decode($dataplayer, 1);
        
        $orderID = "ORDER ID - $order_id";
        
        $judul   = str_replace('_', ' ', $type);
        $judul   = ucwords($judul);
        $content = array(
            'en' => $orderID
        );
        
        $text = str_replace("&amp;", "n", $text);

        ($order_id == 'custom_form' or $order_id == 'abandoned_cart') ? $typemsg = $player_id : $typemsg = get_post_meta($order_id, 'woowa_apk_order', true);
        (strpos($type, "seller") === 0) ? $typemsg = get_option('woowa_save_default_device') : NULL;
        
        foreach ($dataplayer as $key => $value) {
            if (get_option('woowa_android_version') == 'version1') {
                $playerID  = trim($value['player_id']);
                $fields = array(
                    'app_id' => OS_APP_ID,
                    'include_player_ids' => ["$playerID"],
                    'data' => array('type' => $judul, 'message' => $text, 'no_wa' => $data['no_wa_tujuan']),
                    // 'large_icon' =>"https://woo-wa.com/wp-content/uploads/2018/12/Woowa-Bulat-Hijau-200px.png",
                    'contents' => $content,
                    'headings' => array(
                        'en' => $judul,
                    ),
                );
                
                $fields = json_encode($fields);
                
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, OS_URL);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json; charset=utf-8',
                'Authorization: Basic '.OS_AUTH, ));
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_POST, true);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    
                $response = curl_exec($ch);
                curl_close($ch);
            }else {
                $playerID  = trim($value['player_id']);
                $param = array(
                    'data' => array(
                        "message"   => $text,
                        //, "schedule" => '2020-05-13 11:21:15',
                        "number"     => $data['no_wa_tujuan']
                    ),
                    'to' => $playerID
                );
                
                $data_json = json_encode($param);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, 'https://fcm.googleapis.com/fcm/send');
                curl_setopt( $ch,CURLOPT_POST, true );
                curl_setopt( $ch,CURLOPT_RETURNTRANSFER, true );
                curl_setopt( $ch,CURLOPT_POSTFIELDS, $data_json);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    'Content-Type: application/json',
                    'Authorization: Bearer AIzaSyCyXH1aC4rWgMQhaJuQLUTDXfWRBgrCZF4')); //os_auth don't change
                $response = curl_exec($ch);
                curl_close($ch);
                
                woowa_writelog("#".$order_id." Order ID - Send ".$judul." Message to ".$data['no_wa_tujuan']);
            }
        }
    }

    public function android_validation($data){
        $data_api = $data['data_api'];

        $text     = $data_api['text'];
        $file     = $data_api['file'];
        $type     = $data_api['type'];
        $order_id = $data_api['order_id'];
        $no_wa    = $data_api['no_wa_tujuan'];

        $text = str_replace('&', 'n', $text);
        
        $kirim = 'no';
        
        if(get_option("woowa_toggle_cs_rotator") != '') {
            $kirim = 'ok';
        }
        
        if ($kirim=='ok') {
            $datacs = get_option('woowa_customer_service_data');
            $dt_cs  = json_decode($datacs,1);
            $jmlh   = count($dt_cs);

            if ( get_option('woowa_current_cs_rotator') != true ) { add_option('woowa_current_cs_rotator',1);}
            
            if (get_option('woowa_current_cs_rotator') > $jmlh) {
                update_option('woowa_current_cs_rotator', 1);
                $this->writelog('List CS now start from 1');
            }
            
            if (strpos($type, 'seller') !== 0) {
                $dt_cs = array_values($dt_cs);
                foreach ($dt_cs as $k_cs => $v_cs){
                    $current_cs_rotator = get_option('woowa_current_cs_rotator');
                    $cs_id = $k_cs+1;
                    $wa_cs = $no_wa_tujuan;
                    $player_id = $v_cs['player_id'];

                    if ($current_cs_rotator == $cs_id) {
                        if (!empty(get_option('woowa_toggle_customer_service'.$current_cs_rotator))){
                            if (get_post_meta($order_id, 'cs_rotator', true) == 'belum' ) {
                                $current_cs_rotator = get_option('woowa_current_cs_rotator');
                                $data_api['player_id'] = $player_id;
                                $data_api['name'] = $name;
                                update_post_meta($order_id, 'cs_rotator', 'sudah');
                                if (get_post_meta($order_id, 'woowa_apk_order', TRUE) == 'kosong') {
                                    $next_cs_rotator = $current_cs_rotator+1;
                                    update_option('woowa_current_cs_rotator', $next_cs_rotator);
                                    update_post_meta($order_id, 'woowa_apk_order', $player_id);
                                }
                                
                            }
                        }else {
                            $next_cs_rotator = $current_cs_rotator+1;
                            update_option('woowa_current_cs_rotator', $next_cs_rotator);
                            if ($next_cs_rotator > $jmlh) {
                                update_option('woowa_current_cs_rotator', 1);
                                $next_cs_rotator = get_option('woowa_current_cs_rotator');
                                
                                if ($next_cs_rotator == $cs_id){
                                    if (!empty(get_option('woowa_toggle_customer_service'.$next_cs_rotator))) {
                                        if (get_post_meta($order_id, 'cs_rotator', true) == 'belum' ) {
                                            $current_cs_rotator = get_option('woowa_current_cs_rotator');
                                            $data_api['player_id'] = $player_id;
                                            $data_api['name'] = $name;
                                            update_post_meta($order_id, 'cs_rotator', 'sudah');
                                            if (get_post_meta($order_id, 'woowa_apk_order', TRUE) == 'kosong') {
                                                $next_cs_rotator = $current_cs_rotator+1;
                                                update_option('woowa_current_cs_rotator', $next_cs_rotator);
                                                update_post_meta($order_id, 'woowa_apk_order', $player_id);
                                            }
                                            
                                        }
                                    }else {
                                        $last_cs_rotator = $next_cs_rotator+1;
                                        update_option('woowa_current_cs_rotator', $last_cs_rotator);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        
        return $data_api;
    }

    public function get_data_order($order_id, $type ='after_checkout'){
        if (get_option('woowa_license_type') == 'android') {
            if ($type != 'abandoned_cart') {
                $data = $this->order_validation($order_id, $type);
                $data = $this->android_validation($data);
            }
        }else {
            $data = $this->order_validation($order_id, $type);
        }

        return $data;
    }

    public function order_validation($order_id, $type ='after_checkout'){
        $order = wc_get_order($order_id);
        foreach ($order->get_items() as $item_key => $item_values):
            $item_id           = $item_values->get_id();
            $item_name         = $item_values->get_name();
            $item_data         = $item_values->get_data();
            $item_type         = $item_values->get_type();
            $product           = $item_values->get_product();
            $product_id        = $item_values->get_product_id();
            $product_link      = get_permalink($product_id);
            $product_links[]   = get_permalink($product_id);

            $line_total             = $item_data['total'];
            $quantity               = $item_data['quantity'];
            $line_subtotal          = $item_data['subtotal'];
            $line_total_tax         = $item_data['total_tax'];
            $tax_class              = $item_data['tax_class'];
            $product_id             = $item_data['product_id'];
            $line_subtotal_tax      = $item_data['subtotal_tax'];
            $variation_id           = $item_data['variation_id'];
            $Arrproduct_name[]      = $item_data['name'].' x '.$quantity;
            $Arrproduct_name_link[] = $item_data['name'].' x '.$quantity."\n".$product_link;
        endforeach;

        $woowa_additional_info = get_post_meta( $order_id, 'woowa_meta_box_slug', true );

        $postmetas = get_post_meta($order_id);
        foreach($postmetas as $meta_key=>$meta_value) {
            $$meta_key = $meta_value[0];
        }

        if (!empty($Arrproduct_name_link)) {
            $product_name_link = implode("\n", $Arrproduct_name_link);
        }else {
            $product_name_link = '';
        }
        
        if (!empty($product_links)) {
            $product_link = implode("\n", $product_links);
        }else {
            $product_link = '';
        }
        
        if (!empty($Arrproduct_name)) {
            $product_name = implode("\n", $Arrproduct_name);
        }else {
            $product_name = '';
        }
        $ast_no_resi          = get_post_meta($order_id , '_wc_shipment_tracking_items', true )[0]['tracking_number'];
        // $ast_link_tracking    = 'https://resi.id/s/'.$ast_no_resi;

        $shipping = $order->get_items( 'shipping' );
        $resi     = get_post_meta($order_id , '_indo_ongkir_resi', true );

        $array_recipt = [];
        $array_recipt_after = [];

        foreach ($shipping as $item_id => $item) {
            $item_resi = isset( $resi[$item_id] ) ? $resi[$item_id] : '';
            $x = $item->get_name();
            $y = $item_resi;
            $z = $item->get_total();

            $meta_items1 = $item->get_meta( 'Items' );
            $meta_items = str_replace("&times;", "x", $meta_items1);
            if ($meta_items == '' || empty($meta_items)) {
                $meta_items = $product_name;
            }

            $array_recipt_after[] = "Produk : ".$meta_items."\r\nExpedisi : ".$x."\r\nTarif Ongkir : ".$z;
            $array_recipt[] = "Produk : ".$meta_items."\r\nExpedisi : ".$x."\r\nTarif Ongkir : ".$z."\r\nNo. Resi : ".$y;
        }

        $indo_ongkir_resi = implode("\r\n\r\n", $array_recipt);
        $indo_ongkir = implode("\r\n\r\n", $array_recipt_after);
        
        $shipping_add = [
            'firstname'  => $order->get_shipping_first_name(),
            'lastname'   => $order->get_shipping_last_name(),
            'address1'   => $order->get_shipping_address_1(),
            'address2'   => $order->get_shipping_address_2(),
            'city'       => $order->get_shipping_city(),
            'zipcode'    => $order->get_shipping_postcode(),
            'total'      => $order->get_total(),
            'state_name' => $order->get_shipping_state(),
            'country'    => $order->get_shipping_country(),
        ];

        $data                 = $order->get_data();
        $status               = $order->get_status();
        $version              = $order->get_version();
        $currency             = $order->get_currency();
        $parent_id            = $order->get_parent_id();
        $date_created         = $order->get_date_created();
        $order_comments       = $order->get_customer_note();
        $payment_method       = $order->get_payment_method();
        $transaction_id       = $order->get_transaction_id();
        $shipping_method      = $order->get_shipping_method();
        $payment_method_title = $order->get_payment_method_title();

        $timezone = get_option('timezone_string');
        if (empty($timezone) or $timezone == '') {
            // $timezone="Asia/Jakarta";
        } else {
            date_default_timezone_set($timezone);
        }
            
        (isset($date_created)) ? $order_date_created = date( 'j F Y, g:i a') : $order_date_created = '';

        $date_modified = $order->get_date_modified();
        (isset($date_modified)) ? $timestamp_modified = $date_modified->getTimestamp() : $timestamp_modified = '';
        
        $customer_id    = $data['customer_id'];
        $total          = $order->get_cart_tax();
        $total_tax      = $order->get_total_tax();
        $discount_tax   = $order->get_discount_tax();
        $shipping_tax   = $order->get_shipping_tax();
        $shipping_total = $order->get_shipping_total();
        $discount_total = $order->get_discount_total();

        //# BILLING INFORMATION:
        $billing_city       = $order->get_billing_city();
        $billing_state_code = $order->get_billing_state();
        $billing_email      = $order->get_billing_email();
        $billing_phone      = $order->get_billing_phone();
        $billing_company    = $order->get_billing_company();
        $billing_country    = $order->get_billing_country();
        $billing_postcode   = $order->get_billing_postcode();
        $billing_address_1  = $order->get_billing_address_1();
        $billing_address_2  = $order->get_billing_address_2();
        $billing_last_name  = $order->get_billing_last_name();
        $billing_first_name = $order->get_billing_first_name();

        $billing_state = WC()->countries->get_states( $billing_country )[$billing_state_code];

        $total_bayar  = number_format($shipping_add['total'], wc_get_price_decimals(), wc_get_price_decimal_separator(), wc_get_price_thousand_separator());
        $total_amount = trim($total_bayar);

        //# SHIPPING INFORMATION:
        $shipping_city       = $order->get_shipping_city();
        $shipping_state_code = $order->get_shipping_state();
        $shipping_country    = $order->get_shipping_country();
        $shipping_company    = $order->get_shipping_company();
        $shipping_postcode   = $order->get_shipping_postcode();
        $shipping_last_name  = $order->get_shipping_last_name();
        $shipping_address_1  = $order->get_shipping_address_1();
        $shipping_address_2  = $order->get_shipping_address_2();
        $shipping_first_name = $order->get_shipping_first_name();

        $shipping_state      = WC()->countries->get_states( $shipping_country )[$shipping_state_code];
        $methods             = WC()->payment_gateways->payment_gateways();
        $bacs_class          = $methods['bacs'];
        $no_rek_all          = "\n";

        foreach ($bacs_class->account_details as $k => $v) {
            $count = $k + 1;
            $a  = "nama_rek$count";
            $$a = $bacs_class->account_details[$k]['account_name'];
            $b  = "nama_bank$count";
            $$b = $bacs_class->account_details[$k]['bank_name'];
            $c  = "no_rek$count";
            $$c = $bacs_class->account_details[$k]['account_number'];
            $no_rek_all .= 'Rek : '.$$b.' '.$$c.' a.n : '.$$a."\n\n";

            $a  = "account_name$count";
            $$a = $bacs_class->account_details[$k]['account_name'];
            $b  = "bank_name$count";
            $$b = $bacs_class->account_details[$k]['bank_name'];
            $c  = "account_number$count";
            $$c = $bacs_class->account_details[$k]['account_number'];
        }

        $reminder_diff_template = get_option('woowa_reminder_diff_template');

        if ($type == 'reminder_order') {
            $bulk_template = get_post_meta($order_id, 'bulk_template', true);
            if (!empty($bulk_template)) {
                for ($i = 0; $i < 4; ++$i) {
                    if ($bulk_template == 0) {
                        $rp_Pesan = get_option('woowa_pesan_reminder_order');

                        if (!empty(get_option('woowa_check_reminder_order'))) {
                            $data_api['file'] = get_option('woowa_pesan_reminder_order_gambar');
                        } else {
                            $data_api['file'] = '';
                        }

                        update_post_meta($order_id, 'bulk_template', '');
                    } elseif ($bulk_template == $i) {
                        $rp_Pesan = get_option("woowa_pesan_reminder_order$i");

                        if (!empty(get_option("woowa_check_reminder_order$i"))) {
                            $data_api['file'] = get_option("woowa_pesan_reminder_order_gambar$i");
                        } else {
                            $data_api['file'] = '';
                        }

                        update_post_meta($order_id, 'bulk_template', '');
                    }
                }
            } else {
                $set_pesan = get_post_meta($order_id, 'kirim_wa_ke', true);
                if (empty($reminder_diff_template)) {
                    $rp_Pesan = get_option('woowa_pesan_reminder_order');
                } else {
                    for ($i = 1; $i <= 3; ++$i) {
                        if ($set_pesan == 0) {
                            $rp_Pesan = get_option('woowa_pesan_reminder_order');
                            if (!empty(get_option('woowa_check_reminder_order'))) {
                                $data_api['file'] = get_option('woowa_pesan_reminder_order_gambar');
                            } else {
                                $data_api['file'] = '';
                            }
                        } elseif ($set_pesan == $i) { 
                            update_post_meta($order_id, 'kirim_wa_ke', $i);
                            $rp_Pesan = get_option("woowa_pesan_reminder_order$i");
                            if (!empty(get_option("woowa_check_reminder_order$i"))) {
                                $data_api['file'] = get_option("woowa_pesan_reminder_order_gambar$i");
                            } else {
                                $data_api['file'] = '';
                            }
                        }
                    }
                }
            }
        } else {
            $rp_Pesan = get_option('woowa_pesan_'.$type);
        }

        $rp_Pesan=str_replace("'","",$rp_Pesan);
        $rp_Pesan=str_replace('"',"",$rp_Pesan);
        $rp_Pesan=str_replace('$',"",$rp_Pesan);

        $today              = date('Y-m-d H:i');
        $gmt                = get_option('gmt_offset');
        $timezone           = get_option('timezone_string');
        $schedule_number    = get_option('woowa_schedule_number');
        $time_followup      = get_option('time_order_complete_followup');
        $togggle_followup   = get_option('woowa_toggle_order_complete_followup');
        $time_type          = get_option('woowa_time_type_followup_order_completed');
        $time_limit         = get_option('woowa_time_limit_followup_order_completed');
        $send_followup      = '';

        if (!empty(get_option('timezone_string'))) {
            date_default_timezone_set($timezone);
            $today = date('Y-m-d H:i');
        }else {
            $today = gmdate("Y-m-d H:i:s", time() + 3600*($gmt+date("I")));
        }


        if ($type == 'order_complete_followup') {
            if ($time_type == 'day') {
                $send_followup = date('Y-m-d H:i', strtotime($today .'+'. $time_limit.' days', strtotime($today)));
            }else {
                $send_followup = date('Y-m-d H:i', strtotime($today .'+'. $time_limit.' hours', strtotime($today)));
            }
        }

        $customfilename = WOOWA_PATH.'modules/custom_features/custom_features.php';
        if (file_exists($customfilename)) {
            if ($type == 'pending_payment') {
                if (get_option('woowa_toggle_pending_payment_custom') == 'checked') {
                    $json = get_option('woowa_pp_custom_features_data');
                    $arrray_customfeatures = json_decode($json);
                    
                    foreach ($arrray_customfeatures as $key => $value) {
                        if (strtolower($value->title) == strtolower($payment_method_title)) {
                            $rp_Pesan = get_option('woowa_pesan_pp_custom_features'.$key);
                        }
                    }
                }
            }

            if ($type == 'order_complete') {
                if (get_option('woowa_toggle_order_completed_custom') == 'checked') {
                    $json = get_option('woowa_oc_custom_features_data');
                    $arrray_customfeatures = json_decode($json);
                    
                    foreach ($arrray_customfeatures as $key => $value) {
                        if (strtolower($value->title) == strtolower($shipping_method)) {
                            $rp_Pesan = get_option('woowa_pesan_oc_custom_features'.$key);
                        }
                    }
                }
            }

            if (substr('order_complete_followup', 0, 23) == 'order_complete_followup') {
                if (get_option('woowa_toggle_orderfollowup_custom') == 'checked') {
                    $json = get_option('woowa_order_followup_custom_data');
                    $arrray_customfeatures = json_decode($json);
                    $time_type  = get_option("woowa_time_type_".$type);
                    $time_limit = get_option("woowa_time_limit_".$type);
                    
                    $order_followup_time = get_post_meta($order_id, 'order_followup_time', true);
                    if ($order_followup_time == '' || empty($order_followup_time) || $order_followup_time < $today) {
                        $order_followup_time = $today;
                    }


                    if ($time_type == 'day') {
                        $send_followup = date('Y-m-d H:i', strtotime($order_followup_time .'+'. $time_limit.' days', strtotime($order_followup_time)));
                        update_post_meta($order_id, 'order_followup_time', $send_followup);
                    }else {
                        $send_followup = date('Y-m-d H:i', strtotime($order_followup_time .'+'. $time_limit.' hours', strtotime($order_followup_time)));
                        update_post_meta($order_id, 'order_followup_time', $send_followup);
                    }
                }
            }
        }

        $site_url = get_site_url();

        $rp_Pesan = str_replace('{', '$', $rp_Pesan);
        $rp_Pesan = str_replace('}', '', $rp_Pesan);
        $pesan_eval = '$isi="'.$rp_Pesan.'";';
        eval($pesan_eval);
        $text = stripslashes($isi);
        $text = str_replace("\'", "'", $text);

        $all_bank_account = $no_rek_all;

        
        $no_wa_tujuan = $this->phone_validation($billing_phone, $billing_country);

        $site_url = str_replace('https://', '', $site_url);
        $site_url = str_replace('http://', '', $site_url);
        $site_url = str_replace('www.', '', $site_url);
        $site_url_arr = explode('/', $site_url);
        
        if (is_array($site_url_arr)) {
            $site_url = $site_url_arr[0];
        }
        
        
        if ($type != 'reminder_order') {
            if (!empty(get_option("woowa_check_$type"))) {
                if (!empty(get_option("woowa_image_$type"))) {
                    $data_api['file'] = get_option("woowa_image_$type"); 
                }
            } else {
                $data_api['file'] = '';
            }
        }

        $bdata = array(
            'kota'         => $billing_city,
            'produk'       => $product_name,
            'nama_pembeli' => "$billing_first_name $billing_last_name",
            'email'        => $billing_email,
            'no_hp'        => $billing_phone,
            'provinsi'     => $billing_state,
            'negara'       => $billing_country,
            'alamat'       => "$billing_address_1 $billing_address_2",
            'kodepos'      => $billing_postcode,
        );

        
        $ip  = trim(get_option('woowa_ip'));

        if (get_option('woowa_toggle_token') == 'checked') {
            $key = $this->get_key_token($order_id);
        }else {
            $key = get_option('woowa_api_key');
        }

        $data_api['ip']           = $ip;
        $data_api['key']          = $key;
        $data_api['text']         = $text;
        $data_api['type']         = $type;
        $data_api['domain']       = $site_url;
        $data_api['order_id']     = $order_id;
        $data_api['no_wa_tujuan'] = $no_wa_tujuan;
        $data_api['country_code'] = $billing_country;
        $data_api['bdata']        = json_encode($bdata);
        $data_api['license']      = get_option('woowa_license_number');
        $data_api['order_complete_followup'] = $send_followup;

        $return['data_api'] = $data_api;

        return $return;
    }

    public function phone_validation($billing_phone, $billing_country){
        $nom = trim($billing_phone);
        $nom = filter_var($nom, FILTER_SANITIZE_NUMBER_INT);
        $nom = str_replace("-","",$nom);
        $nom = str_replace("+","",$nom);
        $nom = str_replace("(","",$nom);
        $nom = str_replace(")","",$nom);
        $nom = str_replace(" ","",$nom);
        
        if(class_exists('WooPhoneInput_Init')){
            $no_wa_tujuan = '+'.$nom;
        }else{
            $kode = get_option('woowa_default_country_code');
            if($kode==""){
                if(substr($nom,0,2)=="62"){
                    $no_wa_tujuan = '+'.$nom;
                }elseif(substr($nom,0,1)=="0"){
                    $no_wa_tujuan = '+62'.$nom;
                    $no_wa_tujuan = str_replace("+620","+62",$no_wa_tujuan);
                }else{
                    $no_wa_tujuan = '+'.$nom;
                }
            }else{
                if(substr($nom,0,2)==$kode){
                    $no_wa_tujuan = '+'.$nom;
                }elseif(substr($nom,0,1)=="0"){
                    if ($kode=="62") {
                        // indonesia depan 0 jadi +62
                        $no_wa_tujuan = '+'.$kode.$nom;
                        $no_wa_tujuan = str_replace("+0","+62",$no_wa_tujuan);
                        $no_wa_tujuan = str_replace("+620","+62",$no_wa_tujuan);
                    }elseif ($kode=="60") {
                        // malaysia depan 0 jadi +60
                        $no_wa_tujuan = '+6'.$nom;
                        $no_wa_tujuan = str_replace("+600","+60",$no_wa_tujuan);
                    }else{
                        $no_wa_tujuan = '+'.$kode.$nom;
                    }
                }else{
                    if(get_option('woowa_default_country_code_huruf')=='br'){
                        $no_wa_tujuan = '+'.$kode.$nom;
                    }else{
                        $no_wa_tujuan = '+'.$nom;
                    }
                }
            }
            $no_wa_tujuan = str_replace("++","+",$no_wa_tujuan);
        }
        return $no_wa_tujuan;
    }

    public function writelog($n){
        if($n != ''){
            $timezone = get_option('timezone_string');
            if (empty($timezone) or $timezone == '') {
                // $timezone="Asia/Jakarta";
            } else {
                date_default_timezone_set($timezone);
            }
            $fp = fopen(__DIR__.'/../error/error.log', 'a');
            $notallow = array('select ', 'insert ', 'replace ', 'order by', 'group by', 'update ', '{', 'http');
            $tulis = 0;
            foreach ($notallow as $k) {
                if (strpos(strtolower($n), 'select') !== false) {
                } else {
                    $tulis = 1;
                }
            }
            if ($tulis == 1) {
                if (empty($timezone)) {
                    $gmt = get_option('gmt_offset');
                    $date = gmdate("d-m-Y H:i:s", time() + 3600*($gmt+date("I")));
                    fwrite($fp, $date.' :: '.$n."\n");
                }else {
                    fwrite($fp, date('d-m-Y H:i:s').' :: '.$n."\n");
                }
            }
            fclose($fp);
        }
    }

    public function get_key_token($order_id){
        $json = get_option('woowa_token_data');
        $data = json_decode($json, 1);
        $count = count($data);
        $toggletabtoken = true;
        $keytoken = get_option('woowa_key_token');
        
        if ($toggletabtoken == true) {
            if (get_post_meta($order_id, 'woowa_key_token', true)) {
                $token = get_post_meta($order_id, 'woowa_key_token', true);
            }else {
                foreach ($data as $key => $value) {
                    $token = '';
                    $toggle_token = get_option('woowa_toggle_token'.$key);
                    if ($key == $keytoken && $token == '') {
                        if (!empty($toggle_token)) {
                            $token = $value['token'];
                            update_post_meta($order_id, 'woowa_key_token', $token);
                            break;
                        }else {
                            $keytoken = $keytoken+1;
                        }
                    }
                }
            }
        }else {
            $token = trim(get_option('woowa_api_key'));
        }

        $keytoken = update_option('woowa_key_token', $keytoken+1);
        if (get_option('woowa_key_token') > $count && $token == '') {
            $token = get_option('woowa_api_key');
            update_option('woowa_key_token', 1);
        }

        return $token;
    }
}