<?php

woowa_hook_wpajax('save_order_complete');
woowa_hook_wpajax('onoff_order_complete');
woowa_hook_wpajax('order_completed_message');

function woowa_send_order_completed( $order_id, $type = "order_complete" ){
    if (get_option('woowa_license_type') == 'multivendor') {
        woowa_sendapi($order_id, $type);
    }else {
        $main_customer = new MainCustomer();
        $data = $main_customer->get_setting($order_id, $type);
        $main = new Main();
        if ($data['flow'] == true){
            $data = $main->get_data_order($order_id, $type);
            if ($data['data_api']['file'] != '') {
                $main->send_image($data);
            }
            $data = $main->send_message($data);
        }
        $main->writelog($data['log']);
    }
}
add_action('woocommerce_order_status_completed', 'woowa_send_order_completed', 10, 1);

function woowa_send_seller_completed( $order_id, $type = 'completed'){
    if (get_option('woowa_license_type') == 'multivendor') {
        woowa_sendapi($order_id, $type);
    }else {
        $main        = new Main();
        $main_seller = new MainSeller();
        $data        = $main_seller->get_setting($order_id, $type);
        if ($data['flow'] == true){
            $data = $data['wa_number'];
            foreach ($data as $key => $no_wa) {
                $data  = $main->get_data_order($order_id, 'seller_notification'.$type);
                $data['data_api']['no_wa_tujuan'] = $no_wa;
                
                $data = $main->send_message($data);
                
                if ($data['data_api']['file'] != '') {
                    $main->send_image($data);
                }

                $main->writelog($data['log']);
            }
        }
    }
}
add_action('woocommerce_order_status_completed', 'woowa_send_seller_completed', 10, 1);

function woowa_order_complete_followup($order_id, $type = 'order_followup_custom'){
    if (!empty(get_option('woowa_toggle_orderfollowup_custom'))) {
        $main_customer = new MainCustomer();
        $data = $main_customer->get_setting($order_id, $type);
        $main = new Main();
        $followuptemplates = get_option('woowa_order_followup_custom_data');
        $followuptemplates = json_decode($followuptemplates);
        foreach ($followuptemplates as $key => $value) {
            if (get_option('woowa_toggle_order_followup_custom'.$key) != '') {
                $data = $main->get_data_order($order_id, 'order_followup_custom'.$key);
                $data = $main->send_schedule_message($data);
                $main->writelog($data['log']);
            }
        }
    }else{
        $main_customer = new MainCustomer();
        $data = $main_customer->get_setting($order_id, $type);
        $main = new Main();
        if ($data['flow'] == true){
            $data = $main->get_data_order($order_id, $type);
            if (get_option('woowa_check_order_complete_followup') == 'checked') {
                $data = $main->send_schedule_image($data);
            }else {
                $data = $main->send_schedule_message($data);
            }
    
            if ($data['response'] == 'sch_more_than_3_in_1_minute') {
                if (get_option('woowa_check_order_complete_followup') == 'checked') {
                    $data = $main->send_schedule_image($data);
                }else {
                    $data = $main->send_schedule_message($data);
                }
            }
            $main->writelog($data['log']);
        }
    }

}

add_action('woocommerce_order_status_completed', 'woowa_order_complete_followup', 10, 1);